/****************************************************************************/
/* Ώۃ}CR R8C/M12A                                                    */
/* ̧ٓe     v|̃pXM                                  */
/* o[W   Ver.1.00                                                    */
/* Date         2012.07.08                                                  */
/* Copyright    lTX}CRJ[[                            */
/****************************************************************************/
/*
R8C/M12A}CR̃sAL̂悤Ɍ܂B
 1(P4_2)  2(P3_7)  3(PA_0)  4(P4_7) 6(P4_6) 9(P3_5) 10(P3_4) 11(P3_3) 12(P4_5)
ڑ    ڑ   ڑ   ڑ  ٽ ڑ ڑ   ڑ   ڑ

13(P1_7) 14(P1_6) 15(P1_5) 16(P1_4) 17(P1_3) 18(P1_2) 19(P1_1) 20(P1_0)
LED7     LED6     LED5     LED4     LED3     LED2     LED1     LED0
*/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include "sfr_r8m12a.h"                 /* R8C/M12A SFR̒`t@C   */

/*======================================*/
/* vg^Cv錾                     */
/*======================================*/
void init( void );

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/
unsigned int    pulse_width;            /* pX 150[ns]      */

/************************************************************************/
/* CvO                                                     */
/************************************************************************/
void main( void )
{
    init();                             /*                        */

    while( 1 ) {
        // pulse_width̒l
        // T[{90x(0.7ms)/50ns = 14000(256Ŋ 54(0b00110110))
        // T[{   0x(1.5ms)/50ns = 30000(256Ŋ117(0b01110101))
        // T[{E90x(2.3ms)/50ns = 46000(256Ŋ179(0b10110011))

        p1 = pulse_width / 256;
    }
}

/************************************************************************/
/* R8C/M12A XyVt@NVWX^(SFR)̏               */
/************************************************************************/
void init( void )
{
    /* |[g̓o͐ݒ */
    pd1 = 0xff;                         /* |[g1̓o͐ݒ          */
    pd3 = 0xff;                         /* |[g3̓o͐ݒ          */
    pd4 = 0xbf;                         /* |[g4̓o͐ݒ          */
    pda = 0xff;                         /* |[gA̓o͐ݒ          */

    /* ^C}RJ2̐ݒ */
    msttrj  = 0;                        /* ^C}RJ2Lɂ        */

//  p15sel2 = 0;                        /* P1_5TRJIO[qɂ        */
//  p15sel1 = 1;
//  p15sel0 = 0;

//  p17sel1 = 1;                        /* P1_7TRJIO[qɂ        */
//  p17sel0 = 0;

    p46sel2 = 1;                        /* P4_6TRJIO[qɂ        */
    p46sel1 = 0;
    p46sel0 = 1;

    tck2_trjmr   = 0;                   /* JEg\[X = f1          */
    tck1_trjmr   = 0;
    tck0_trjmr   = 0;
    tmod2_trjmr  = 0;                   /* pX胂[h           */
    tmod1_trjmr  = 1;
    tmod0_trjmr  = 1;
    tedgsel_trjioc = 1;                 /* Hx𑪒                */
    trj          = 0xffff;              /* TRJɍől          */
    trjie_trjir  = 1;                   /* TRJ荞݋              */
    ilvlb        = 0x02;                /* 荞ݗD惌x2          */
    tstart_trjcr = 1;                   /* Ͻ                      */

    /* S̊荞݂̋ */
    asm(" fset I ");                    /* Ŝ̊荞݋           */
}

/************************************************************************/
// ^C}RJ2荞ݏ
/************************************************************************/
#pragma interrupt intTRJ(vect=22)
void intTRJ( void )
{
    if( tundf_trjcr ) {                 /* A_t[H           */
        // 50ns~65536=3.2768msȏONȂAvłȂ
        tundf_trjcr = 0;
    }

    if( tedgf_trjcr ) {                 /* 茟o               */
        tedgf_trjcr = 0;

        /* pXZbg */
        pulse_width = 0xffff - trj;

        /* JE^NA(~ăZbg) */
        tstart_trjcr = 0;               /* TRJ~                      */
        trj          = 0xffff;
        tstart_trjcr = 1;               /* TRJĊJ                      */
    }
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/
